{* 
** APR Loan Calculator by Robert Lake
**  (c) Robert Lake 1996
** This software is freeware - please see documentation 
** V1.0 - Nov 1996 - Initial Coding
*}

Declare Function ActivateGadget(gad&,wdw&,req&) Library intuition

{*
** define constants so that gadgets can be referred to by name
** rather than number
*}

CONST NULL = 0&
CONST close_wnd = 256
CONST cash = 255
CONST exchange = 254
CONST deposit = 253
CONST credit = 252
CONST acceptance = 251
CONST purchase = 250
CONST charges = 249
CONST total = 248
CONST installments = 247
CONST rate = 246
CONST repayments = 245

{* Define the font to be used here *}
GLOBAL STRING fnt$
fnt$ = "thinpaz.font"

{* Show calculations to 2 dp *}
FIX -3

SUB NextGad(ADDRESS wdw, SHORTINT theGadget)
{*
** This subroutine activates the next gadget 
** to be filled - moving the cursor to the 
** gadget
*}

ADDRESS gad
  Gadget Output theGadget
  gad = Gadget(4)
  If gad <> NULL Then Call ActivateGadget(gad,wdw,NULL)

END SUB

SUB CalcCredit
{*
** Calculate the required credit
*}
  GADGET OUTPUT cash
  c!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT exchange
  e!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT deposit
  d!=VAL(CSTR(GADGET(2)))

  cr!=c!-e!-d!
  cr$=STR$(cr!)
	
  GADGET CLOSE credit
  GADGET credit,OFF,cr$,(165,80)-(270,98),STRING

END SUB

SUB CalcRepayments
{*
** Calculate the repayments
*}
  GADGET OUTPUT rate
  r!=VAL(CSTR(GADGET(2)))
  i!=r!/1200.00

  GADGET OUTPUT credit
  l!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT installments
  m!=VAL(CSTR(GADGET(2)))
	
  rp!=i!*l!/(1.00-((1.00+i!)^(-m!))) 

  rp$=STR$(rp!)
	
  GADGET CLOSE repayments
  GADGET repayments,OFF,rp$,(165,220)-(270,238),STRING

END SUB

SUB CalcCharges
{*
** Calculate the charges
*}
  GADGET OUTPUT repayments
  r!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT installments
  i!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT credit
  c!=VAL(CSTR(GADGET(2)))

  ch!=r!*i!-c!
  ch$=STR$(ch!)
	
  GADGET CLOSE charges
  GADGET charges,OFF,ch$,(165,140)-(270,158),STRING

END SUB

SUB CalcTotal
{*
** Calculate the total credit price
*}
  GADGET OUTPUT cash
  c!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT charges
  ch!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT acceptance
  a!=VAL(CSTR(GADGET(2)))

  GADGET OUTPUT purchase
  p!=VAL(CSTR(GADGET(2)))

  t!=c!+ch!+a!+p!
  t$=STR$(t!)
	
  GADGET CLOSE total
  GADGET total,OFF,t$,(165,160)-(270,178),STRING
END SUB

SUB About
{*
** Create the APR Loan Calculator About box
*}
SHORTINT theGadget, n
  WINDOW 8,"About",(240,50)-(400,168),2
  {* RENDER GADGETS, BEVEL-BOXES AND TEXT *}
  FONT fnt$,8 : STYLE 0  : COLOR 2,0 : PENUP : SETXY 6,91
  PRINT "Programmed in ACE Basic";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 33,78
  PRINT "by Robert Lake";
  FONT fnt$,8 : STYLE 2  : COLOR 2,0 : PENUP : SETXY 20,12
  PRINT "APR Loan Calculator";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 63,26
  PRINT "V1.0";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 34,39
  PRINT "November 1996";
  SLEEP FOR 3
  WINDOW CLOSE 8 
END SUB

SUB CloseWnd
{*
** delete gadgets & close window
*}
  IF MsgBox("Please confirm close","Confirmed","No!") THEN
	FOR n=255 TO 245 STEP -1
	  GADGET CLOSE n
	NEXT
	WINDOW CLOSE 9
     STOP
  ELSE
  	{* Move the cursor to cash gadget *}
  	NextGad(WINDOW(7),cash)
  END IF 
END SUB

SUB Menu_Handler
{*
** Menu handlers
*}
  x=menu(0) : y=menu(1)
  if x=1 and y=2 then CALL CloseWnd 
  if x=1 and y=1 then CALL About
END SUB

SUB Gadget_Handler
{*
** Gadget handlers
*}
SHORTINT theGadget, n

  theGadget = GADGET(1)

  CASE
	theGadget = cash : ~
			CALL CalcCredit : ~
		     CALL CalcRepayments : ~
			CALL CalcCharges : ~
		     CALL CalcTotal : ~
			NextGad(WINDOW(7),exchange)

     theGadget = exchange : ~
			CALL CalcCredit : ~
		     CALL CalcRepayments : ~
			CALL CalcCharges : ~
		     CALL CalcTotal : ~
			NextGad(WINDOW(7),deposit)

     theGadget = deposit : ~
			CALL CalcCredit : ~
		     CALL CalcRepayments : ~
			CALL CalcCharges : ~
		     CALL CalcTotal : ~
			NextGad(WINDOW(7),acceptance)

  	theGadget = acceptance : ~
		     CALL CalcTotal : ~
			NextGad(WINDOW(7),purchase)

	theGadget = purchase : ~
		     CALL CalcTotal : ~
			NextGad(WINDOW(7),installments)

	theGadget = installments : ~
			GADGET OUTPUT installments : ~
			i!=VAL(CSTR(GADGET(2))) : ~
			IF i! >= 12 and i! <= 120 THEN
			     CALL CalcRepayments : ~
				CALL CalcCharges : ~
			     CALL CalcTotal : ~
				NextGad(WINDOW(7),rate)
			ELSE
				MsgBox "Instalments must be in the range 12 to 120","OK" : ~
				NextGad(WINDOW(7),installments)
			END IF

	theGadget = rate : ~
			GADGET OUTPUT rate : ~
			r!=VAL(CSTR(GADGET(2))) : ~
			IF r! >= 0.1 THEN
			     CALL CalcRepayments : ~
				CALL CalcCharges : ~
			     CALL CalcTotal : ~
				NextGad(WINDOW(7),cash)
			ELSE
				MsgBox "Rate must be greater than 0.1%","OK" : ~
				NextGad(WINDOW(7),rate)
			END IF		

  END CASE

END SUB

SUB APRLoan
{*
** Create the APR Loan main window
** and react to any gadgets used 
*}

{*
* Declare window & setup window handling
*}
  WINDOW 9,"APR Loan Calculator",(164,0)-(485,255),30
  ON WINDOW CALL CloseWnd
  WINDOW ON
{*
* define menu & enable menu handling
*
*}
  MENU 1,0,1,"Project"
  MENU 1,1,1,"About"
  MENU 1,2,1,"Exit   ","E"
  ON MENU CALL Menu_Handler
  MENU ON
{*
* RENDER GADGETS, BEVEL-BOXES AND TEXT, turn on Gadget handling
*}
  FONT fnt$,8 : STYLE 2  : COLOR 1,0 : PENUP : SETXY 15,11
  PRINT "Please input details below:";
  GADGET cash,ON,"0.00",(165,20)-(270,38),STRING
  GADGET exchange,ON,"0.00",(165,40)-(270,58),STRING
  GADGET deposit,ON,"0.00",(165,60)-(270,78),STRING
  GADGET credit,ON,"0.00",(165,80)-(270,98),STRING
  GADGET acceptance,ON,"0.00",(165,100)-(270,118),STRING
  GADGET purchase,ON,"0.00",(165,120)-(270,138),STRING
  GADGET charges,OFF,"0.00",(165,140)-(270,158),STRING
  GADGET total,OFF,"0.00",(165,160)-(270,178),STRING
  GADGET installments,ON,"12",(165,180)-(270,198),STRING
  GADGET rate,ON,"12.00",(165,200)-(270,218),STRING
  GADGET repayments,OFF,"0.00",(165,220)-(270,238),STRING
  ON GADGET CALL Gadget_Handler
  GADGET ON

  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 91,28
  PRINT "Cash Price";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 73,48
  PRINT "Part Exchange";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 79,68
  PRINT "Cash Deposit";
  FONT fnt$,8 : STYLE 0  : COLOR 3,0 : PENUP : SETXY 61,88
  PRINT "Required Credit";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 67,108
  PRINT "Acceptance Fee";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 79,128
  PRINT "Purchase Fee";
  FONT fnt$,8 : STYLE 0  : COLOR 3,0 : PENUP : SETXY 67,148
  PRINT "Credit Charges";
  FONT fnt$,8 : STYLE 0  : COLOR 3,0 : PENUP : SETXY 43,168
  PRINT "Total Credit Price";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 50,188
  PRINT "No of Instalments";
  FONT fnt$,8 : STYLE 0  : COLOR 1,0 : PENUP : SETXY 36,208
  PRINT "Interest Rate(APR%)";
  FONT fnt$,8 : STYLE 0  : COLOR 2,0 : PENUP : SETXY 43,228
  PRINT "Monthly Repayments";

  {* Move the cursor to cash gadget *}
  NextGad(WINDOW(7),cash)

  {* GADGET HANDLING STARTS HERE *}
  WHILE -1 
	SLEEP
  WEND

END SUB

{*
** Main Loop
**
*}

CALL APRLoan
END